// IceCreamClient.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "afxwin.h"
#include "iostream.h"
#include <stdio.h>
#include <conio.h>
#include <tchar.h>
#include <vector>    //STL include



//import typelibrary and set namespace
#import "IceCream.tlb"
using namespace ICECREAMLib;



void main(int argc, char* argv[])
{


	
	HRESULT hr = S_OK;	
	long lStartBound =0;
	long lEndBound = 0;
	long lDimension[2];
	VARIANT varSafe;


	//Initialize OLE
	CoInitialize(NULL);

	try
	{


		//Use a smart pointer
		IIceCreamOrderPtr ptrIceCreamOrder(__uuidof(IceCreamOrder));


		//Get all the flavors and prices
		//As a multidimensional safe array
		hr = ptrIceCreamOrder->GetFlavorsWithPrices(&varSafe);

		if(FAILED (hr))
		{

			//Couldn't get flavors and prices
			//Probably the icecream parlor is closed :-)
			//Bail out
			return;

		}

		
		
		// Get the Upper and lower bound of the returned array
		SAFEARRAY* pSafeArray  = varSafe.parray;
		hr = SafeArrayGetLBound(pSafeArray, 1, &lStartBound);
		hr = SafeArrayGetUBound(pSafeArray, 1, &lEndBound);

			

		
		

		for(int iIndex = lStartBound; iIndex <= lEndBound; iIndex ++)
		{
			
			

			//Extract the flavor information from the array
			VARIANT varFlavor;
			lDimension[1] = iIndex;
			lDimension[0] = 0;

			hr = SafeArrayGetElement(pSafeArray, lDimension, &varFlavor);

			if(hr != S_OK)
			{
				return;
			}


			//Extract the price information from the array
			VARIANT varPrices;
			lDimension[1] = iIndex;
			lDimension[0] = 1;

			hr = SafeArrayGetElement(pSafeArray, lDimension, &varPrices);
			if(hr != S_OK)
			{
				return;

			}

			printf("%20ls ------------ %.2f\r\n", varFlavor.bstrVal,varPrices.fltVal);
			
			

			if(varFlavor.bstrVal)
			{
				::SysFreeString(varFlavor.bstrVal);
			}
			

		
			
			
	

		}//for loop


	
   }//try


   catch(_com_error e)
   {
	   cout << "Encountered Error \r\n";
	   cout << e.Error();
	   cout <<	e.ErrorMessage();
      
   }


   //Uninitialize OLE
   CoUninitialize();





}
